MSWriteParser Class Reference documentation

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Private Member Functions | Private Attributes | Friends | List of all members
MSWriteParser Class Reference

This class parses Microsoft Write 3.0 and 3.1. More...

`#include <MSWrite.h>`

Inheritance diagram for MSWriteParser:

## Public Member Functions
| MSWriteParser (RVNGInputStreamPtr &input, WPSHeaderPtr &header, libwps_tools_win::Font::Type encoding=libwps_tools_win::Font::WIN3_WEUROPE)
| ~MSWriteParser ()
void | parse (librevenge::RVNGTextInterface *const documentInterface)
Public Member Functions inherited from WPSParser
| WPSParser (RVNGInputStreamPtr &input, WPSHeaderPtr &header)
virtual | ~WPSParser ()

## Private Member Functions
| MSWriteParser (const MSWriteParser &)
MSWriteParser & | operator= (const MSWriteParser &)
shared_ptr< WPSContentListener > | createListener (librevenge::RVNGTextInterface *interface)
void | readFIB ()
void | readFFNTB ()
void | readSECT ()
void | readPAP ()
void | readCHP ()
void | findZones ()
void | readText (WPSEntry e)
void | processObject (WPSPosition &pos, unsigned long lastPos)
bool | processDDB (librevenge::RVNGBinaryData &bmpdata, WPSPosition &pos, unsigned width, unsigned height, unsigned byte_width, unsigned planes, unsigned bits_pixel, unsigned size)
bool | processDIB (librevenge::RVNGBinaryData &bmpdata, unsigned size)
bool | processWMF (librevenge::RVNGBinaryData &wmfdata, unsigned size)
void | processEmbeddedOLE (WPSPosition &pos, unsigned long lastPos)
bool | processStaticOLE (librevenge::RVNGBinaryData &, std::string &mimetype, WPSPosition &pos, unsigned long lastPos)
bool | readString (std::string &res, unsigned long lastPos)
unsigned | insertString (const unsigned char *str, unsigned size, libwps_tools_win::Font::Type type)
bool | checkFilePosition (uint32_t pos) const
| check if the file position is correct or not More...

## Private Attributes
uint32_t | m_fileLength
| the last file position More...
uint32_t | m_fcMac
std::vector< MSWriteParserInternal::Paragraph > | m_paragraphList
std::vector< MSWriteParserInternal::Font > | m_fontList
std::vector< librevenge::RVNGString > | m_fonts
WPSPageSpan | m_pageSpan
libwps_tools_win::Font::Type | m_fontType
shared_ptr< WPSContentListener > | m_listener
WPSEntry | m_Main
WPSEntry | m_Header
WPSEntry | m_Footer
bool | m_HeaderPage1
bool | m_FooterPage1

## Friends
class | MSWriteParserInternal::SubDocument
struct | MSWriteParserInternal::Paragraph
struct | MSWriteParserInternal::Font

## Additional Inherited Members
Public Types inherited from WPSParser
typedef std::multimap< std::string, WPSEntry > | NameMultiMap
| a map to retrieve a file entry by name More...
Protected Member Functions inherited from WPSParser
RVNGInputStreamPtr & | getInput ()
RVNGInputStreamPtr | getFileInput ()
WPSHeaderPtr & | getHeader ()
int | version () const
void | setVersion (int vers)
libwps::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...
NameMultiMap & | getNameEntryMap ()
NameMultiMap const & | getNameEntryMap () const

## Detailed Description

This class parses Microsoft Write 3.0 and 3.1.

## Constructor & Destructor Documentation

MSWriteParser::MSWriteParser | ( | RVNGInputStreamPtr & | input,
|  | WPSHeaderPtr & | header,
|  | libwps_tools_win::Font::Type | encoding = `libwps_tools_win::Font::WIN3_WEUROPE`
| ) |  |

MSWriteParser::~MSWriteParser | ( |  | ) |

MSWriteParser::MSWriteParser | ( | const MSWriteParser & |  | ) |
| private

## Member Function Documentation

bool MSWriteParser::checkFilePosition | ( | uint32_t | pos | ) | const
| inlineprivate

check if the file position is correct or not

Referenced by processEmbeddedOLE(), processObject(), readCHP(), readFFNTB(), readFIB(), readPAP(), readSECT(), and readString().

shared_ptr< WPSContentListener > MSWriteParser::createListener | ( | librevenge::RVNGTextInterface * | interface | ) |
| private

Referenced by parse().

void MSWriteParser::findZones | ( |  | ) |
| private

Referenced by parse().

unsigned MSWriteParser::insertString | ( | const unsigned char * | str,
|  | unsigned | size,
|  | libwps_tools_win::Font::Type | type
| ) |  |
| private

Referenced by readText().

MSWriteParser& MSWriteParser::operator= | ( | const MSWriteParser & |  | ) |
| private

void MSWriteParser::parse | ( | librevenge::RVNGTextInterface *const | documentInterface | ) |
| virtual

Implements WPSParser.

bool MSWriteParser::processDDB | ( | librevenge::RVNGBinaryData & | bmpdata,
|  | WPSPosition & | pos,
|  | unsigned | width,
|  | unsigned | height,
|  | unsigned | byte_width,
|  | unsigned | planes,
|  | unsigned | bits_pixel,
|  | unsigned | size
| ) |  |
| private

Referenced by processObject(), and processStaticOLE().

bool MSWriteParser::processDIB | ( | librevenge::RVNGBinaryData & | bmpdata,
|  | unsigned | size
| ) |  |
| private

Referenced by processStaticOLE().

void MSWriteParser::processEmbeddedOLE | ( | WPSPosition & | pos,
|  | unsigned long | lastPos
| ) |  |
| private

Referenced by processObject().

void MSWriteParser::processObject | ( | WPSPosition & | pos,
|  | unsigned long | lastPos
| ) |  |
| private

Referenced by readText().

bool MSWriteParser::processStaticOLE | ( | librevenge::RVNGBinaryData & | b,
|  | std::string & | mimetype,
|  | WPSPosition & | pos,
|  | unsigned long | lastPos
| ) |  |
| private

Referenced by processEmbeddedOLE(), and processObject().

bool MSWriteParser::processWMF | ( | librevenge::RVNGBinaryData & | wmfdata,
|  | unsigned | size
| ) |  |
| private

Referenced by processObject(), and processStaticOLE().

void MSWriteParser::readCHP | ( |  | ) |
| private

Referenced by parse().

void MSWriteParser::readFFNTB | ( |  | ) |
| private

Referenced by parse().

void MSWriteParser::readFIB | ( |  | ) |
| private

Referenced by parse().

void MSWriteParser::readPAP | ( |  | ) |
| private

Referenced by parse().

void MSWriteParser::readSECT | ( |  | ) |
| private

Referenced by parse().

bool MSWriteParser::readString | ( | std::string & | res,
|  | unsigned long | lastPos
| ) |  |
| private

Referenced by processEmbeddedOLE(), and processStaticOLE().

void MSWriteParser::readText | ( | WPSEntry | e | ) |
| private

Referenced by parse(), and MSWriteParserInternal::SubDocument::parse().

## Friends And Related Function Documentation

friend struct MSWriteParserInternal::Font
| friend

friend struct MSWriteParserInternal::Paragraph
| friend

friend class MSWriteParserInternal::SubDocument
| friend

## Member Data Documentation

uint32_t MSWriteParser::m_fcMac
| private

Referenced by findZones(), readCHP(), readFIB(), readPAP(), and readText().

uint32_t MSWriteParser::m_fileLength
| private

the last file position

Referenced by checkFilePosition(), and MSWriteParser().

std::vector<MSWriteParserInternal::Font> MSWriteParser::m_fontList
| private

Referenced by readCHP(), and readText().

std::vector<librevenge::RVNGString> MSWriteParser::m_fonts
| private

Referenced by readCHP(), and readFFNTB().

libwps_tools_win::Font::Type MSWriteParser::m_fontType
| private

Referenced by MSWriteParser(), readCHP(), and readFFNTB().

WPSEntry MSWriteParser::m_Footer
| private

Referenced by createListener(), and findZones().

bool MSWriteParser::m_FooterPage1
| private

Referenced by createListener(), and findZones().

WPSEntry MSWriteParser::m_Header
| private

Referenced by createListener(), and findZones().

bool MSWriteParser::m_HeaderPage1
| private

Referenced by createListener(), and findZones().

shared_ptr<WPSContentListener> MSWriteParser::m_listener
| private

Referenced by insertString(), parse(), processEmbeddedOLE(), processObject(), and readText().

WPSEntry MSWriteParser::m_Main
| private

Referenced by findZones(), and parse().

WPSPageSpan MSWriteParser::m_pageSpan
| private

Referenced by createListener(), readPAP(), and readSECT().

std::vector<MSWriteParserInternal::Paragraph> MSWriteParser::m_paragraphList
| private

Referenced by findZones(), readPAP(), and readText().

The documentation for this class was generated from the following files:

- MSWrite.h
- MSWrite.cpp